//+------------------------------------------------------------------+
//|                                            EMA x 4TimeFrames.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property link      "Modified by cja" 

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Aqua
#property indicator_color2 Yellow
#property indicator_color3 Magenta
#property indicator_color4 Lime

extern bool Show_EMA_TEXT = true;
extern int Shift_text = 4;//1/2/3/4

//---- input parameters
extern int EMAPeriod=21;           
           
extern int SEMAPeriod=21;          
           
extern int SSEMAPeriod=21;  

extern int SSSEMAPeriod=21;        
           
//---- indicator buffers
double ExtBuffer1[];
double ExtBuffer2[];
double ExtBuffer3[];
double ExtBuffer4[];

int deinit()
  {
  ObjectsDeleteAll(0,OBJ_LABEL);
 return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
//---- 3 indicator buffers mapping
   SetIndexBuffer(0,ExtBuffer1);
   SetIndexBuffer(1,ExtBuffer2);
   SetIndexBuffer(2,ExtBuffer3);
   SetIndexBuffer(3,ExtBuffer4);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE,EMPTY,2);
   SetIndexStyle(1,DRAW_LINE,EMPTY,2);
   SetIndexStyle(2,DRAW_LINE,EMPTY,2);
   SetIndexStyle(3,DRAW_LINE,EMPTY,2);
//---- index labels
  
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| 3 X EMA                                          |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- main loop
   for(int i=0; i<limit; i++)
     {
      ExtBuffer1[i]=iMA(NULL,5,EMAPeriod,0,MODE_EMA,PRICE_CLOSE,i); 
      ExtBuffer2[i]=iMA(NULL,60,SEMAPeriod,0,MODE_EMA,PRICE_CLOSE,i); 
      ExtBuffer3[i]=iMA(NULL,240,SSEMAPeriod,0,MODE_EMA,PRICE_CLOSE,i); 
      ExtBuffer4[i]=iMA(NULL,1440,SSSEMAPeriod,0,MODE_EMA,PRICE_CLOSE,i);
     }
     
    if (Show_EMA_TEXT==true) 
   { 
      ObjectDelete("EMA5");
   EMA5( "EMA5", 20, 12,Shift_text);
   ObjectSetText( "EMA5","M5 EMA "+EMAPeriod+""  , 10, "Arial", indicator_color1);
      ObjectDelete("EMA60");
   EMA60( "EMA60", 40, 12,Shift_text);
   ObjectSetText( "EMA60","H1 EMA "+SEMAPeriod+""  , 10, "Arial", indicator_color2);
       ObjectDelete("EMA240");
   EMA240( "EMA240", 60, 12,Shift_text);
   ObjectSetText( "EMA240","H4 EMA "+SSEMAPeriod+""  , 10, "Arial", indicator_color3);
       ObjectDelete("EMA1440");
   EMA1440( "EMA1440", 80, 12,Shift_text);
   ObjectSetText( "EMA1440","D1 EMA "+SSSEMAPeriod+""  , 10, "Arial", indicator_color4);
   }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+
  int EMA5( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 20);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}
  int EMA60( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 20);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}
  int EMA240( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 20);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}
  int EMA1440( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 20);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}